import { VaguelyIterable, ExtendedAsyncIterable } from "./extended_async_iterable";
export declare class ByteReader {
    private iterable;
    iter: AsyncIterator<Uint8Array>;
    saved: Uint8Array[];
    size: number;
    ended: boolean;
    bytesRead: number;
    id: number;
    constructor(iterable: AsyncIterable<Uint8Array>);
    toIterable(): ExtendedAsyncIterable<Uint8Array>;
    read(size: number): Promise<Uint8Array | undefined>;
    private fill;
    private fillTo;
    private splitOff;
    private find;
    readUntilMatch(test: (buffer: Uint8Array) => number): Promise<Uint8Array | undefined>;
    readUntil(byte: number): Promise<Uint8Array | undefined>;
    streamUntilMatch(test: (buffer: Uint8Array) => number, sizeHint?: number): ExtendedAsyncIterable<Uint8Array>;
    streamUntilBuffer(match: Uint8Array): ExtendedAsyncIterable<Uint8Array>;
    unread(buffer: Uint8Array): void;
    remainder(): Uint8Array | undefined;
    toString(): string;
}
export declare function byteReader(wrapped: VaguelyIterable<Uint8Array>, getDebugName?: () => string): ByteReader;
export declare function concatBuffers(buffers: Uint8Array[]): Uint8Array;
